Index: /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 98)
@@ -1,28 +1,8 @@
 package com.framsticks.diagnostics;
 
-import java.util.Date;
-import java.io.File;
-import java.io.FileOutputStream;
-import java.io.IOException;
-import java.io.OutputStreamWriter;
-import java.io.PrintWriter;
-import java.text.SimpleDateFormat;
 
-import org.apache.log4j.Logger;
-
-import com.framsticks.core.AbstractTreeListener;
 import com.framsticks.core.Tree;
-import com.framsticks.core.Path;
-import com.framsticks.dumping.PrintWriterSink;
-import com.framsticks.dumping.SaveStream;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
-import com.framsticks.remote.RecursiveFetcher;
-import com.framsticks.util.FramsticksException;
-import com.framsticks.util.PeriodicTask;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.JoinableCollection;
-import com.framsticks.util.dispatching.ThrowExceptionHandler;
-import com.framsticks.util.io.Encoding;
 
 /**
@@ -30,5 +10,4 @@
  */
 public class Diagnostics extends JoinableCollection<Tree> {
-	private static final Logger log = Logger.getLogger(Diagnostics.class);
 
 
@@ -48,51 +27,51 @@
 		super.add(tree);
 
-		tree.addListener(new AbstractTreeListener() {
-			@Override
-			public void onRun(Exception e) {
-				if (e != null) {
-					return;
-				}
+		// tree.addListener(new AbstractTreeListener() {
+		// 	@Override
+		// 	public void onRun(Exception e) {
+		// 		if (e != null) {
+		// 			return;
+		// 		}
 
-				if (dumpsInterval != null) {
-					new PeriodicTask<Tree>(ThrowExceptionHandler.getInstance(), tree, dumpsInterval * 1000) {
-						protected final ExceptionResultHandler repeater = new ExceptionResultHandler() {
+		// 		if (dumpsInterval != null) {
+		// 			new PeriodicTask<Tree>(ThrowExceptionHandler.getInstance(), tree, dumpsInterval * 1000) {
+		// 				protected final ExceptionResultHandler repeater = new ExceptionResultHandler() {
 
-							@Override
-							public void handle(FramsticksException exception) {
-								log.error("caught error during diagnostics fetching (repeating): " + exception);
-								again();
-							}
+		// 					@Override
+		// 					public void handle(FramsticksException exception) {
+		// 						log.error("caught error during diagnostics fetching (repeating): " + exception);
+		// 						again();
+		// 					}
 
-						};
-						@Override
-						protected void runAt() {
+		// 				};
+		// 				@Override
+		// 				protected void runAt() {
 
-							log.info("starting periodic dump");
-							new RecursiveFetcher(tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
+		// 					log.info("starting periodic dump");
+		// 					new RecursiveFetcher(tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
 
-								@Override
-								protected void result(Void result) {
-									log.info("tree resolved, saving");
-									try {
-										final String fileName = dumpsPath + "/" + tree + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
-										File file = new File(fileName);
-										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
+		// 						@Override
+		// 						protected void result(Void result) {
+		// 							log.info("tree resolved, saving");
+		// 							try {
+		// 								final String fileName = dumpsPath + "/" + tree + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
+		// 								File file = new File(fileName);
+		// 								new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
 
-											@Override
-											protected void result(Void result) {
-												again();
-											}
-										});
-									} catch (IOException e) {
-										throw new FramsticksException().msg("failed to initiate dump").cause(e);
-									}
-								}
-							});
-						}
-					};
-				}
-			}
-		});
+		// 									@Override
+		// 									protected void result(Void result) {
+		// 										again();
+		// 									}
+		// 								});
+		// 							} catch (IOException e) {
+		// 								throw new FramsticksException().msg("failed to initiate dump").cause(e);
+		// 							}
+		// 						}
+		// 					});
+		// 				}
+		// 			};
+		// 		}
+		// 	}
+		// });
 
 
Index: /java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 98)
@@ -59,6 +59,8 @@
 					if (line.equals("ok")) {
 						if (query.first.equals("get")) {
-							Path path = TreeOperations.createIfNeeded(tree, query.second);
-							TreeOperations.processFetchedValues(path, files);
+							// Path path = null;
+							throw new UnimplementedException().msg("rework load stream");
+							// Path path = TreeOperations.createIfNeeded(tree, query.second);
+							// TreeOperations.processFetchedValues(path, files);
 						} else if (query.first.equals("info")) {
 							assert files.size() == 1;
Index: /java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 98)
@@ -14,5 +14,4 @@
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 import org.apache.log4j.Logger;
@@ -48,6 +47,5 @@
 	protected void dispatchWrite(final Path path) {
 		++dispatched;
-		//TODO TEH
-		tree.dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+		tree.dispatch(new RunAt<Tree>(tree) {
 			@Override
 			protected void runAt() {
@@ -89,5 +87,5 @@
 			}
 			for (CompositeParam p : filterInstanceof(access.getParams(), CompositeParam.class)) {
-				final Path childPath = path.appendNode(new Node(p, access.get(p, Object.class)));
+				final Path childPath = path.appendNode(new Node(path.getTree(), p, access.get(p, Object.class)));
 				if (childPath.isResolved() && getInfoFromCache(childPath) != null) {
 					dispatchWrite(childPath);
Index: /java/main/src/main/java/com/framsticks/gui/AbstractNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/AbstractNode.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/AbstractNode.java	(revision 98)
@@ -0,0 +1,18 @@
+package com.framsticks.gui;
+
+
+import com.framsticks.gui.view.TreeCellRenderer;
+
+public abstract class AbstractNode {
+
+	public AbstractNode() {
+	}
+
+	public abstract int getChildCount();
+	public abstract AbstractNode getChild(int number);
+	public abstract int getIndexOfChild(AbstractNode child);
+
+	public abstract boolean isLeaf();
+	public abstract void render(TreeCellRenderer renderer);
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 98)
@@ -14,5 +14,4 @@
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -46,4 +45,5 @@
 
 	protected final List<PopupMenuEntryProvider> popupMenuEntryProviders = new LinkedList<>();
+	// protected final SwingDispatcher
 
 	protected final MainFrame mainFrame;
@@ -63,4 +63,7 @@
 
 		mainFrame = new MainFrame(Browser.this);
+
+		// mainFrame.getStatusBar().setExceptionHandler(ThrowExceptionHandler.getInstance());
+
 		addFrame(mainFrame);
 
@@ -120,26 +123,27 @@
 	public void addTree(Tree tree) {
 		log.info("adding tree: " + tree);
+		tree.setDispatcher(new SwingDispatcher<Tree>());
 		trees.add(tree);
 	}
 
 	public void autoResolvePath(final String path, final Future<Path> future) {
-		final Tree i = trees.get("localhost");
-		i.dispatch(new RunAt<Tree>(future) {
-			@Override
-			protected void runAt() {
-				TreeOperations.resolveAndGet(i, path, new FutureHandler<Path>(future) {
-					@Override
-					protected void result(final Path p) {
-						future.pass(p);
-						mainFrame.dispatch(new RunAt<Frame>(future) {
-							@Override
-							protected void runAt() {
-								mainFrame.goTo(p);
-							}
-						});
-					}
-				});
-			}
-		});
+		// final Tree i = trees.get("localhost");
+		// i.dispatch(new RunAt<Tree>(future) {
+		// 	@Override
+		// 	protected void runAt() {
+		// 		TreeOperations.tryGet(i, path, new FutureHandler<Path>(future) {
+		// 			@Override
+		// 			protected void result(final Path p) {
+		// 				future.pass(p);
+		// 				mainFrame.dispatch(new RunAt<Frame>(future) {
+		// 					@Override
+		// 					protected void runAt() {
+		// 						mainFrame.goTo(p);
+		// 					}
+		// 				});
+		// 			}
+		// 		});
+		// 	}
+		// });
 	}
 
@@ -284,7 +288,22 @@
 	}
 
-	// @Override
-	// public boolean isDone() {
-	//	return frames.isDone() && trees.isDone();
+	// final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
+	// public boolean hasSubscribed(EventParam param) {
+	// 	assert frame.isActive();
+	// 	return userSubscriptions.containsKey(param);
 	// }
+
+	// public void unsubscribe(EventParam eventParam) {
+	// 	assert frame.isActive();
+	// 	if (!hasSubscribed(eventParam)) {
+	// 		log.error("could not unsubscribe from " + eventParam);
+	// 		return;
+	// 	}
+	// 	userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback(log, "unsubscribed " + eventParam));
+	// 	userSubscriptions.remove(eventParam);
+	// }
+
+
+
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/EmptyNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/EmptyNode.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/EmptyNode.java	(revision 98)
@@ -0,0 +1,50 @@
+package com.framsticks.gui;
+
+
+import com.framsticks.gui.view.TreeCellRenderer;
+import com.framsticks.params.CompositeParam;
+
+public class EmptyNode extends AbstractNode {
+
+	protected final CompositeParam param;
+
+	/**
+	 * @param param
+	 */
+	public EmptyNode(CompositeParam param) {
+		this.param = param;
+	}
+
+	@Override
+	public int getChildCount() {
+		return 0;
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		return null;
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		return -1;
+	}
+
+	@Override
+	public boolean isLeaf() {
+		return true;
+	}
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		renderer.setIcon(ImageProvider.loadImage(TreeCellRenderer.findIconName(param)));
+		renderer.setText(param.getId());
+		renderer.setToolTipText("?");
+	}
+
+	@Override
+	public String toString() {
+		return param.toString();
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 98)
@@ -11,5 +11,5 @@
 import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
-import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.Map;
 
@@ -28,10 +28,8 @@
 import javax.swing.ToolTipManager;
 import javax.swing.UIManager;
-import javax.swing.event.TreeModelEvent;
-import javax.swing.event.TreeModelListener;
+import javax.swing.event.TreeExpansionEvent;
+import javax.swing.event.TreeExpansionListener;
 import javax.swing.event.TreeSelectionEvent;
 import javax.swing.event.TreeSelectionListener;
-import javax.swing.tree.DefaultMutableTreeNode;
-import javax.swing.tree.DefaultTreeModel;
 import javax.swing.tree.DefaultTreeSelectionModel;
 import javax.swing.tree.TreePath;
@@ -40,16 +38,16 @@
 import org.apache.log4j.Logger;
 
+import com.framsticks.core.Mode;
 import com.framsticks.core.Path;
 import com.framsticks.core.Tree;
+import com.framsticks.core.TreeOperations;
 import com.framsticks.gui.view.TreeCellRenderer;
-import com.framsticks.util.FramsticksException;
+import com.framsticks.params.AccessInterface;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
-import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.lang.ScopeEnd;
 import com.framsticks.util.swing.KeyboardModifier;
 import com.framsticks.util.swing.MenuConstructor;
@@ -72,11 +70,12 @@
 	protected JScrollPane treeScrollPane;
 	protected JTree jtree;
-	protected DefaultTreeModel treeModel;
-	protected javax.swing.tree.MutableTreeNode rootNode;
+	protected TreeModel treeModel;
+
+	protected MetaNode rootNode;
+
 	protected JPanel treePanel;
 	protected JPopupMenu treePopupMenu;
 	protected JMenuItem treePopupMenuHeader;
 
-	TreeNode currentlyPoppedTreeNode;
 	protected JPanel mainPanel;
 	protected JPanel leftPanel;
@@ -91,6 +90,6 @@
 	protected JMenu helpMenu;
 
-	protected final Map<Tree, TreeAtFrame> treeAtFrames = new HashMap<Tree, TreeAtFrame>();
-	protected JoinableCollection<Tree> trees = new JoinableCollection<Tree>();
+	protected final Map<Tree, TreeAtFrame> treeAtFrames = new IdentityHashMap<>();
+	protected JoinableCollection<Tree> trees = new JoinableCollection<>();
 
 	public Frame(Browser browser) {
@@ -106,5 +105,4 @@
 		log.debug("creating " + this);
 
-
 		Container contentPane = getSwing().getContentPane();
 		treePopupMenu = new JPopupMenu("title");
@@ -114,27 +112,7 @@
 		treePanel.setLayout(new BorderLayout());
 
-		treeModel = new DefaultTreeModel(null);
-		treeModel.addTreeModelListener(new TreeModelListener() {
-
-			@Override
-			public void treeNodesChanged(TreeModelEvent arg0) {
-				log.trace("treeNodesChanged: " + arg0);
-			}
-
-			@Override
-			public void treeNodesInserted(TreeModelEvent arg0) {
-				// log.trace("treeNodesInserted: " + arg0);
-			}
-
-			@Override
-			public void treeNodesRemoved(TreeModelEvent arg0) {
-				log.trace("treeNodesRemoved: " + arg0);
-			}
-
-			@Override
-			public void treeStructureChanged(TreeModelEvent arg0) {
-				log.trace("treeStructureChanged: " + arg0);
-			}
-		});
+		rootNode = new MetaNode();
+		rootNode.setName("root");
+		treeModel = new TreeModel(this);
 
 		jtree = new JTree(treeModel);
@@ -152,7 +130,19 @@
 		});
 
+		jtree.addTreeExpansionListener(new TreeExpansionListener() {
+
+			@Override
+			public void treeCollapsed(TreeExpansionEvent e) {
+
+			}
+
+			@Override
+			public void treeExpanded(TreeExpansionEvent e) {
+				loadChildren(treeModel.convertToPath(e.getPath()), false);
+			}
+		});
+
 		jtree.setExpandsSelectedPaths(true);
 		jtree.setEditable(false);
-		jtree.setDoubleBuffered(true);
 		jtree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
 		jtree.setShowsRootHandles(true);
@@ -173,5 +163,9 @@
 		});
 
-		new KeyboardModifier(jtree, JComponent.WHEN_FOCUSED).join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0)).join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0)).join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0)).join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
+		new KeyboardModifier(jtree, JComponent.WHEN_FOCUSED)
+			.join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0))
+			.join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0))
+			.join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0))
+			.join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
 
 		jtree.setCellRenderer(new TreeCellRenderer());
@@ -182,7 +176,4 @@
 		treePanel.add(treeScrollPane);
 
-		rootNode = new DefaultMutableTreeNode();
-		rootNode.setUserObject("root");
-		treeModel.setRoot(rootNode);
 
 		normalWorkPanel = new JPanel();
@@ -248,4 +239,12 @@
 		});
 
+		new MenuConstructor(fileMenu).add(KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK), new AbstractAction("Reload current") {
+			@Override
+			public void actionPerformed(ActionEvent actionEvent) {
+
+				loadPath(treeModel.convertToPath(jtree.getSelectionPath()), true);
+			}
+		});
+
 	}
 
@@ -254,16 +253,30 @@
 	}
 
-	public void addRootPath(Path path) {
+	public void addRootPath(final Path path) {
 		assert isActive();
+
 		Tree tree = path.getTree();
+
+		log.info("trying mount: " + path);
+		if (!tree.getAssignedRoot().isResolved()) {
+			tree.get(path, Mode.FETCH, new FutureHandler<Path>(this) {
+
+				@Override
+				protected void result(Path result) {
+					addRootPath(result);
+				}
+			});
+			return;
+		}
+
 		assert browser.getTrees().contains(tree);
 
 		TreeAtFrame e = new TreeAtFrame(tree, this);
-		tree.addListener(e);
 		treeAtFrames.put(tree, e);
-		TreeNode node = new TreeNode(e, path);
-		e.rootTreeNode = node;
-		treeModel.insertNodeInto(node, rootNode, rootNode.getChildCount());
-		jtree.expandPath(new TreePath(rootNode));
+
+		rootNode.getChildren().add(new TreeNode(tree.getAssignedRoot()));
+		e.rootNode = tree.getAssignedRoot();
+		treeModel.nodeStructureChanged(new TreePath(rootNode));
+		// jtree.expandPath(new TreePath(rootNode));
 	}
 
@@ -275,4 +288,5 @@
 	}
 
+
 	private void showPopup(MouseEvent e) {
 		assert isActive();
@@ -280,10 +294,7 @@
 			return;
 		}
-		currentlyPoppedTreeNode = findTreeNodeByTreePath(jtree.getPathForLocation(e.getX(), e.getY()));
-		if (currentlyPoppedTreeNode == null) {
-			return;
-		}
-
-		Path path = currentlyPoppedTreeNode.getTreePath();
+		TreePath treePath = jtree.getPathForLocation(e.getX(), e.getY());
+
+		Path path = treeModel.convertToPath(treePath);
 		treePopupMenu.removeAll();
 
@@ -291,16 +302,8 @@
 			provider.provide(treePopupMenu, path);
 		}
-		// treePopupMenuHeader.setText(path.getTree().getName() + path.getTextual());
 		treePopupMenu.show(e.getComponent(), e.getX(), e.getY());
-		//currentlyPoppedPanel.getNode().getFramsClass().getName()
-	}
-
-	public TreeNode getCurrentlyPoppedTreeNode() {
-		assert isActive();
-		return currentlyPoppedTreeNode;
 	}
 
 	public void clear() {
-		treeModel.setRoot(null);
 		cardPanel.removeAll();
 		cardPanel.updateUI();
@@ -308,82 +311,76 @@
 	}
 
-	public ScopeEnd startChange(final DefaultMutableTreeNode node) {
-		assert isActive();
-		final TreePath selection = jtree.getSelectionPath();
-		return new ScopeEnd() {
-			@Override
-			public void close() {
-				assert isActive();
-				treeModel.nodeChanged(node);
-				jtree.setSelectionPath(selection);
-			}
-		};
-	}
-
-	public void selectTreeNode(final TreeNode treeNode) {
-		assert isActive();
-		/*		final Panel panel = treeNode.getOrCreatePanel();
-		 if (panel == null) {
-		 return;
-		 }
-		 panel.setCurrentTreeNode(treeNode);
-		 treeNode.updateData();
-		 showPanel(panel);*/
-	}
-
-	public TreeNode findTreeNodeByTreePath(TreePath treePath) {
+	public void loadChildren(Path path, boolean reload) {
+		if (path == null) {
+			return;
+		}
+		AccessInterface access = TreeOperations.bindAccess(path);
+
+		int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			Path childPath = path.appendParam(access.getCompositeParam(i)).tryFindResolution();
+			loadPath(childPath, reload);
+		}
+
+	}
+
+	public void loadPath(Path path, boolean reload) {
+		if (path == null) {
+			return;
+		}
+		if (path.isResolved() && !reload) {
+			return;
+		}
+		path.getTree().get(path, Mode.FETCH, new FutureHandler<Path>(this) {
+			@Override
+			protected void result(Path result) {
+				final TreePath treePath = treeModel.convertToTreePath(result);
+
+				treeModel.nodeStructureChanged(treePath);
+				if (treePath.equals(jtree.getSelectionPath())) {
+					treeAtFrames.get(result.getTree()).useOrCreatePanel(treePath);
+				}
+			}
+		});
+	}
+
+	public void chooseTreeNode(final TreePath treePath) {
 		assert isActive();
 		if (treePath == null) {
-			return null;
-		}
-		if (!(treePath.getLastPathComponent() instanceof TreeNode)) {
-			return null;
-		}
-		return (TreeNode) treePath.getLastPathComponent();
-	}
-
-	public void chooseTreeNode(TreePath treePath) {
-		assert isActive();
-		final TreeNode treeNode = findTreeNodeByTreePath(treePath);
-		if (treeNode == null) {
-			return;
-		}
-		treeNode.select();
-	}
-
-	protected final ExceptionResultHandler dialogHandler = new ExceptionResultHandler() {
-
-		@Override
-		public void handle(FramsticksException exception) {
-			//TODO TEH
-			throw exception;
-
-		}
-	};
-
-	public void goTo(Path path) {
-		assert isActive();
-		final TreePath treePath = treeAtFrames.get(path.getTree()).getTreePath(path, false);
-		log.info("go to path: " + path + "(" + treePath + ")");
-
-		this.dispatch(new RunAt<Frame>(dialogHandler) {
-			@Override
-			protected void runAt() {
-				log.info("executed");
-				jtree.setSelectionPath(treePath);
-				jtree.makeVisible(treePath);
-				assert jtree.isVisible(treePath);
-			}
-		});
-
-	}
-
-	public void addNode(TreeNode child, DefaultMutableTreeNode parent) {
-		assert isActive();
-
-		try (ScopeEnd e = startChange(parent)) {
-			treeModel.insertNodeInto(child, parent, parent.getChildCount());
-		}
-	}
+			return;
+		}
+		if (treeModel.isChanging()) {
+			return;
+		}
+
+		Path path = treeModel.convertToPath(treePath);
+		if (path == null) {
+			return;
+		}
+		path = path.assureResolved();
+		final Tree tree = path.getTree();
+
+		treeAtFrames.get(tree).useOrCreatePanel(treePath);
+		loadChildren(path, false);
+
+	}
+
+
+	// public void goTo(Path path) {
+	//	assert isActive();
+	//	final TreePath treePath = treeModel.convertToTreePath(path);
+	//	log.info("go to path: " + path + "(" + treePath + ")");
+
+	//	this.dispatch(new RunAt<Frame>(this) {
+	//		@Override
+	//		protected void runAt() {
+	//			log.info("executed");
+	//			jtree.setSelectionPath(treePath);
+	//			jtree.makeVisible(treePath);
+	//			assert jtree.isVisible(treePath);
+	//		}
+	//	});
+
+	// }
 
 	@Override
@@ -422,3 +419,10 @@
 	}
 
+	/**
+	 * @return the treeModel
+	 */
+	public TreeModel getTreeModel() {
+		return treeModel;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/ImageProvider.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 98)
@@ -7,6 +7,7 @@
 
 import javax.swing.*;
+
 import java.util.HashMap;
-import java.util.LinkedHashMap;
+import java.util.Map;
 
 /**
@@ -21,12 +22,12 @@
 	 * HashMap stores icons. Key is icon path, Value is icon.
 	 */
-	private static HashMap<String, ImageIcon> icons = new LinkedHashMap<String, ImageIcon>();
+	private static Map<String, ImageIcon> icons = new HashMap<String, ImageIcon>();
 
 	public static final String IMAGE = "image.png";
 	public static final String LOGO = "logo.png";
 
-	//public static final String FOLDER_OPEN = "folder_open.png";
-	//public static final String FOLDER_CLOSED = "folder_close.png";
-	//public static final String NODE = "node.png";
+	public static final String FOLDER_OPEN = "folder_open.png";
+	public static final String FOLDER_CLOSED = "folder_close.png";
+	public static final String NODE = "node.png";
 
 	public static final String SERVER = "server.png";
Index: /java/main/src/main/java/com/framsticks/gui/ListPanelProvider.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/ListPanelProvider.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/ListPanelProvider.java	(revision 98)
@@ -0,0 +1,15 @@
+package com.framsticks.gui;
+
+import com.framsticks.params.types.ListParam;
+
+public class ListPanelProvider implements PanelProvider {
+
+	@Override
+	public Panel providePanel(Panel.Parameters parameters) {
+		if (parameters.param instanceof ListParam) {
+			return new ListPanel(parameters);
+		}
+		return null;
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/MetaNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/MetaNode.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/MetaNode.java	(revision 98)
@@ -0,0 +1,67 @@
+package com.framsticks.gui;
+
+import java.util.LinkedList;
+import java.util.List;
+
+
+import com.framsticks.gui.view.TreeCellRenderer;
+
+public class MetaNode extends AbstractNode {
+
+	protected List<AbstractNode> children = new LinkedList<>();
+	protected String name = "meta node";
+
+	/**
+	 * @return the children
+	 */
+	public List<AbstractNode> getChildren() {
+		return children;
+	}
+
+	/**
+	 * @return the name
+	 */
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@Override
+	public int getChildCount() {
+		return children.size();
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		return children.get(number);
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		return children.indexOf(child);
+	}
+
+	@Override
+	public String toString() {
+		return name;
+	}
+
+	@Override
+	public boolean isLeaf() {
+		return false;
+	}
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		renderer.setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
+		renderer.setText(name);
+		renderer.setToolTipText("?");
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 98)
@@ -2,4 +2,5 @@
 
 import org.apache.log4j.Logger;
+
 
 import javax.swing.*;
@@ -65,9 +66,4 @@
 	}
 
-	@Override
-	public void setCurrentTreeNode(TreeNode node) {
-		super.setCurrentTreeNode(node);
-	}
-
 	protected abstract void applyChanges();
 
Index: /java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 98)
@@ -4,4 +4,6 @@
 
 import javax.swing.*;
+import javax.swing.tree.TreePath;
+
 import java.awt.*;
 import java.util.List;
@@ -46,8 +48,8 @@
 
 	@Override
-	public void setCurrentTreeNode(TreeNode currentTreeNode) {
-		super.setCurrentTreeNode(currentTreeNode);
+	public void setCurrentTreePath(TreePath currentTreePath) {
+		super.setCurrentTreePath(currentTreePath);
 		for (Panel p : panels) {
-			p.setCurrentTreeNode(currentTreeNode);
+			p.setCurrentTreePath(currentTreePath);
 		}
 	}
Index: /java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java	(revision 98)
@@ -0,0 +1,14 @@
+package com.framsticks.gui;
+
+import java.util.IdentityHashMap;
+import java.util.Map;
+
+import com.framsticks.gui.controls.ValueControl;
+
+public class NodeAtFrame {
+
+	protected Panel panel;
+
+	protected final Map<ValueControl, Object> localChanges = new IdentityHashMap<>();
+
+}
